/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jackrabbit.spi.commons.batch;

import javax.jcr.RepositoryException;

import org.apache.jackrabbit.spi.Batch;

/**
 * An <code>Operation</code> represents a method call on a {@link Batch}.
 */
public interface Operation {

    /**
     * Apply this operation to the given {@link Batch}
     * @param batch
     * @throws RepositoryException
     */
    public void apply(Batch batch) throws RepositoryException;
}
